
#  Convert.py  Copyright (c) Kari Laitinen

#  http://www.naturalprogramming.com

#  2006-04-26  File created.
#  2022-12-18  Converted to Python 3.

#  With this program it is possible to make conversions between
#  some units of measure. A Conversion object represents a
#  conversion between two units.

import sys   # needed when command line parameters are used

class  Conversion :

   def __init__( self, given_first_unit,
                       given_second_unit,
                       given_conversion_constant ) :

      self.first_unit   =  given_first_unit
      self.second_unit  =  given_second_unit
      self.conversion_constant  =  given_conversion_constant


   def convert( self, given_unit, amount_to_convert ) :

      if  self.first_unit.find( given_unit )  !=  -1  :
      
         print(  "\n  %f %s is %f %s"  %  \
           ( amount_to_convert, self.first_unit, \
             amount_to_convert * self.conversion_constant,  self.second_unit), end="" )
   

      if  self.second_unit.find( given_unit )  !=  -1  :
      
         print(  "\n  %f %s is %f %s"  %  \
           ( amount_to_convert, self.second_unit, \
             amount_to_convert / self.conversion_constant,  self.first_unit ), end="" )


#  The main program begins.

#  First we create a conversion table which is a tuple that
#  contains Conversion objects.

conversion_table  =  ( Conversion("meters", "yards", 1.093613 ),
                       Conversion("meters", "feet",  3.280840 ),
                       Conversion("miles",  "kilometers",1.609344),
                       Conversion("inches", "centimeters", 2.54 ),
                       Conversion("acres",  "hectares", 0.4046873),
                       Conversion("pounds", "kilograms",0.4535924),
                       Conversion("ounces", "grams",    28.35 ),
                       Conversion("gallons (U.S.)","liters", 3.785),
                       Conversion("gallons (Br.)", "liters", 4.546),
                       Conversion("pints (U.S.)",  "liters", 0.473),
                       Conversion("pints (Br.)",   "liters", 0.568),
                       Conversion("joules",       "calories",4.187),
                       Conversion("lightyears",   "kilometers", 9.461e12 ) )

command_line_parameters  =  sys.argv[ 1 : ]

if len( command_line_parameters )  ==  2 :

   unit_from_user      =  command_line_parameters[ 0 ]
   amount_to_convert   =  float( command_line_parameters[ 1 ] )
   
else :
      
   print( "\n Give the unit to convert from: ", end="" )
   unit_from_user  =  input()
   print( "\n Give the amount to convert:    ", end="" )
   amount_to_convert  =  float( input() )
   
for conversion_in_table  in  conversion_table  :
      
   conversion_in_table.convert( unit_from_user, \
                                amount_to_convert )

print( "\n" )


#  Another way to write the above for loop is the following:

#for conversion_index  in  range( len( conversion_table ) ) :
      
#   conversion_table[ conversion_index ].convert( unit_from_user, \
#                                                 amount_to_convert )
   


